//=============================================================================
// Potato.
//=============================================================================
class Potato expands Actor;

var string ownersname; //the owner's name
var hotpotato Master; //our controller
var float boringness; //thing we'll need later
var int blabtime;

auto state pickup //auto state, waiting for player to pick us up
{
	function BeginState() //called @ start of state
	{
		SetOwner(None); //make our owner none
		SetBase(None); //ditto w/ the base
		boringness=0; //reset the counter
		DrawType=DT_Mesh; //reset the DT
		blabtime=0;
		LightBrightness=0;
	}
	
	function Tick(float deltatime) //called every time the game is refreshed
	{
		boringness+=deltatime; //add deltatime 2 the counter
		if(boringness>=50) //if the counter's up,
			Destroy(); //destroy us
	}
	
	event Touch(actor Other) //called when something invades our collision area
	{
		if(Other.IsA('Pawn')) { //if the thing that touched us was a pawn
			SetOwner(Other); //make it our owner
			SetBase(Other); //make it our base
			DrawType=DT_None; //reset the DT
			LightBrightness=255;
			GotoState('activated'); //we're now activated
		}
	}
}

state activated //called from prev state
{
	function BeginState() //called @ start of state
	{
		local pawn actFoundPawn; //stuff we need
		ownersname=Pawn(Owner).PlayerReplicationInfo.PlayerName; //store the owner's name
		foreach AllActors(class'Pawn',actFoundPawn) //check all pawns
			actFoundPawn.ClientMessage(ownersname$" picked up the potato!"); //and tell them who's got the potato
		SetTimer(2.0,True); //set the timer
	}
	
	function Tick(float deltatime) //called when world is refreshed
	{
		local pawn guy; //guy we'll need
		
		if(owner==None || Pawn(Owner).Health<=0) { //if our owner's gone or dead
			foreach AllActors(class'Pawn',guy) //check all actors
				guy.clientmessage(ownersname$" lost the potato!"); //and tell them the potato's on the floor
			GotoState('pickup'); //we can now be picked up
		}
	}
	
	function Timer() //called at a predefined interval
	{
		local pawn guy;
		
		Pawn(Owner).PlayerReplicationInfo.Score+=1; //add one to our owner's score
		if(DeathMatchPlus(Level.Game)!=None) { //if this is a UT DM game,
			if(Pawn(Owner).PlayerReplicationInfo.Score>=DeathMatchPlus(Level.Game).Fraglimit && DeathMatchPlus(Level.Game).Fraglimit>0) { //if the fraglimit is unlimited and our owner beat the limit
				Level.Game.EndGame("fraglimit"); //the game is over
				SetTimer(999999999999999999999,False); //makesure the timer doesn't go on again
			}
		}
		LightHue=byte(FRand()*255);
		blabtime++;
		if(blabtime>5) {
			foreach AllActors(class'Pawn',guy)
				guy.ClientMessage(ownersname$" has the Potato!");
			blabtime=0;
		}
	}
}

event destroyed() { //when we get destroyed
	Master.SpawnPotato(); //make another potato
}

defaultproperties
{
     bIsItemGoal=True
     bTravel=True
     RemoteRole=ROLE_SimulatedProxy
     DrawType=DT_Mesh
     Mesh=LodMesh'UnrealShare.TBoulder'
     DrawScale=3.500000
     AmbientGlow=255
     bGameRelevant=True
     CollisionRadius=30.000000
     CollisionHeight=30.000000
     bCollideActors=True
     bCollideWorld=True
     LightType=LT_Steady
     LightEffect=LE_NonIncidence
     LightBrightness=255
     LightRadius=20
     VolumeBrightness=111
     bFixedRotationDir=True
     RotationRate=(Roll=5000)
     NetPriority=2.000000
}
